SystemOrganization addCategory: #Prolog!

Object subclass: #MultiSearchQuery
	instanceVariableNames: 'predicateName data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!MultiSearchQuery methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 13:19'!
data: anArray 
data := anArray! !

!MultiSearchQuery methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 13:21'!
predicateName
	^ predicateName! !

!MultiSearchQuery methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:27'!
predicateName: aSymbol 
predicateName := aSymbol ! !

!Object methodsFor: '*Prolog' stamp: 'HwaJong 10/22/2012 15:34'!
accumulateSearchQuery: aSymbol 
^self! !

!Object methodsFor: '*Prolog' stamp: 'HwaJong 10/21/2012 22:29'!
canBeTrueWith: anObject
^self = anObject  
! !

!Object methodsFor: '*Prolog' stamp: 'HwaJong 10/22/2012 00:42'!
isSearchQuery
^false! !

Object subclass: #PrologKnowledgeBase
	instanceVariableNames: 'entries flatGrandDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:27'!
entryAtPredicateName: aSymbol 
	^entries at: aSymbol ifAbsentPut: [OrderedCollection new] ! !

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 14:07'!
fact: aSymbol data: anArray 
	|o f|
	o := entries at: aSymbol ifAbsentPut: [OrderedCollection new].
	f := Fact factName: aSymbol data: anArray.
	o addLast: f.
	flatGrandDomain addAll: f data.! !

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 13:20'!
flatEntries
	^entries values concatenateAll ! !

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 14:08'!
flatGrandDomain
^flatGrandDomain! !

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 14:06'!
initialize
super initialize.
entries := Dictionary new.
flatGrandDomain := Set new.! !

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 13:37'!
predicateNames
^entries keys! !

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:28'!
query: aSymbol data: anArray 
	(entries includesKey: aSymbol) ifFalse: [^false].
	(entries at: aSymbol) detect: [:each| each isTrueWithName: aSymbol data: anArray ] ifNone: [^false].
	^true! !

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:28'!
queryWhat: aSymbol data: anArray 
| md |
md := TTTMultiDimensionalDo new
	domains: ((1 to: anArray size) collect: [:index| (anArray at: index) isSearchQuery ifTrue: [self flatGrandDomain asArray] ifFalse: [{anArray at: index}]] );
	block: [:array| (self query: aSymbol data: array)
			ifTrue: [ 1 to: anArray size do: [:index| (anArray at: index) accumulateSearchQuery: (array at: index)] ].
		];
	run.! !

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:28'!
rule: aSymbol definition: aBlockClosure 
(self entryAtPredicateName: aSymbol) addLast: (Rule knowledgeBase: self blockClosure: aBlockClosure)! !

Object subclass: #PrologPredicate
	instanceVariableNames: 'predicateName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

PrologPredicate subclass: #Fact
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!Fact classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:30'!
factName: aSymbol data: anArray 
^self new
	factName: aSymbol;
	data: anArray! !

!Fact methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/21/2012 22:29'!
accumulateSearchQueryIfCanBeTrueWith: anArray 
1 to: anArray size do:  [:index | 
	((anArray at: index) canBeTrueWith: (data at: index))
		ifFalse: [^self].
	].

1 to: anArray size do:  [:index |
	(anArray at: index) accumulateSearchQuery: (data at: index) ].! !

!Fact methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 13:23'!
accumulateSearchQueryIfCanBeTrueWithMultiSearchQuery: aMultiSearchQuery 
	aMultiSearchQuery predicateName = self predicateName ifFalse: [^false].
	(1 to: data size) allSatisfy: [:index| (aMultiSearchQuery data at: index) canBeTrueWith: (data at: index) ] ! !

!Fact methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/21/2012 22:11'!
data

	^ data! !

!Fact methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/21/2012 21:46'!
data: anArray 
data := anArray! !

!Fact methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:29'!
factName: aSymbol 
predicateName := aSymbol ! !

!Fact methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:29'!
isTrueWithName: aSymbol data: anArray 
	predicateName = aSymbol ifFalse: [^false].
	data = anArray ifFalse: [^false].
	^true   ! !

!PrologPredicate methodsFor: 'accessing' stamp: 'HwaJong 10/22/2012 13:21'!
predicateName
	^ predicateName! !

PrologPredicate subclass: #Rule
	instanceVariableNames: 'blockClosure knowledgeBase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!Rule classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/21/2012 22:39'!
blockClosure: aBlockClosure 
^self new
	blockClosure: aBlockClosure! !

!Rule classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 12:43'!
knowledgeBase: aPrologKnowledgeBase blockClosure: aBlockClosure 
^self new
	blockClosure: aBlockClosure;
	knowledgeBase: aPrologKnowledgeBase! !

!Rule methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/21/2012 22:45'!
accumulateSearchQueryIfCanBeTrueWith: anArray 
	self shouldBeImplemented.! !

!Rule methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/21/2012 22:39'!
blockClosure: aBlockClosure 
blockClosure := aBlockClosure ! !

!Rule methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:29'!
isTrueWithName: aSymbol data: anArray 
^blockClosure valueWithArguments: anArray. ! !

!Rule methodsFor: 'accessing' stamp: 'HwaJong 10/22/2012 12:42'!
knowledgeBase
	^ knowledgeBase! !

!Rule methodsFor: 'accessing' stamp: 'HwaJong 10/22/2012 12:42'!
knowledgeBase: aPrologKnowledgeBase
	knowledgeBase := aPrologKnowledgeBase
! !

Object subclass: #PrologQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

PrologQuery subclass: #SearchQuery
	instanceVariableNames: 'queryName collectedCases'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!SearchQuery classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/21/2012 22:21'!
withName: aByteString 
^self new
	queryName: aByteString! !

!SearchQuery methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/21/2012 22:31'!
accumulateSearchQuery: anObject
self collectedCases add: anObject
! !

!SearchQuery methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:30'!
canBeTrueWith: aSymbol 
	^true! !

!SearchQuery methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/21/2012 22:31'!
collectedCases
collectedCases isNil ifTrue: [collectedCases := Set new].
^collectedCases! !

!SearchQuery methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 00:42'!
isSearchQuery
^true! !

!SearchQuery methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/21/2012 22:21'!
queryName: aString 
queryName := aString ! !

PrologQuery subclass: #YesNoQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!
